<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
	prefix="carbon"%>
<%@ page import="org.apache.axis2.context.ConfigurationContext"%>
<%@ page import="org.wso2.carbon.CarbonConstants"%>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<%@ page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page import="org.wso2.carbon.identity.entitlement.ui.client.EntitlementPolicyAdminServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="java.util.ResourceBundle" %>
<%@page import="java.lang.Exception"%>
<%@ page import="java.util.List" %>
<%@ page import="org.wso2.carbon.identity.entitlement.ui.EntitlementPolicyConstants" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.identity.entitlement.stub.dto.AttributeValueDTO" %>

<%
    String subjectType = "";
    String action = "";
    String subjectId = "";

    String [] results = null;
    String forwardTo;
    
    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.
                    CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String BUNDLE = "org.wso2.carbon.identity.entitlement.ui.i18n.Resources";
	ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());

    subjectId = (String)request.getParameter("subjectId");
    action = (String)request.getParameter("action");
    subjectType = (String)request.getParameter("subjectType");


    try {
            //Dummy attributeDTO to identitfy the search scenario
            if (subjectId != null && action != null) {
            EntitlementPolicyAdminServiceClient client = new EntitlementPolicyAdminServiceClient(cookie,
                    serverURL, configContext);
            String roleName = null;
            String userName = null;
            if ("role".equals(subjectType)) {
            	roleName = subjectId;
            }else {
            	userName = subjectId;
            }
            results = client.getEntitledAttributes(userName,roleName,action); 
            }
    } catch (Exception e) {
    	String message = resourceBundle.getString("error.while.loading.policy.resource");
        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
        forwardTo = "../admin/error.jsp";
%>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
<%
    }
%>
<fmt:bundle basename="org.wso2.carbon.identity.entitlement.ui.i18n.Resources">
<carbon:breadcrumb
		label="advance.search"
		resourceBundle="org.wso2.carbon.identity.entitlement.ui.i18n.Resources"
		topPage="false"
		request="<%=request%>" />

    <script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
    <script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
    <script type="text/javascript" src="resources/js/main.js"></script>
    <!--Yahoo includes for dom event handling-->
    <script src="../yui/build/yahoo-dom-event/yahoo-dom-event.js" type="text/javascript"></script>
    <script src="../entitlement/js/create-basic-policy.js" type="text/javascript"></script>
    <link href="../entitlement/css/entitlement.css" rel="stylesheet" type="text/css" media="all"/>

<script type="text/javascript">

    function submitForm(){
        document.requestForm.action = "advance-search.jsp";
        document.requestForm.submit();
    }

    function doCancel(){
        location.href = 'index.jsp?';
    }


</script>

<div id="middle">
    <h2><fmt:message key="advance.search"/></h2>
    <div id="workArea">
        <form id="requestForm" name="requestForm" method="post" action="advance-search.jsp">
        <table class="styledLeft noBorders">
        <tr>
            <td  colspan="2">
                <fmt:message key='advance.search.message1'/>
            </td>
        </tr>

        <tr>
            <td class="leftCol-small"><fmt:message key='subjectType'/><span class="required">*</span></td>
            <td colspan="2">
            <select id="subjectType" name="subjectType">
                    <option value="role" selected="selected">Role</option>
                    <option value="user">User</option>
            </select>
            </td>
        </tr>

        <tr>
            <td class="leftCol-small"><fmt:message key='subject.name'/><span class="required">*</span></td>
            <td colspan="2">
            <%
                if (subjectId != null && !subjectId.equals("")) {
            %>
            <input type="text" name="subjectId" id="subjectId"
                       value="<%=subjectId%>" class="text-box-big"/>
            <%
                } else {
            %>
            <input type="text" name="subjectId" id="subjectId" class="text-box-big"/>
            <%
                }
            %>
            </td>
        </tr>
            
        <tr>
            <td class="leftCol-small"><fmt:message key='action'/><span class="required">*</span></td>
            <td colspan="2">
            <%
                if (action != null && !action.equals("")) {
            %>
            <input type="text" name="action" id="action" value="<%=action%>"
                       class="text-box-big"/>
            <%
                } else {
            %>
            <input type="text" name="action" id="action" class="text-box-big"/>
            <%
                }
            %>
            </td>
        </tr>
          

        <tr>
            <td>
                <a class="icon-link" href="#" style="background-image: url(images/search.gif);"
                   onclick="submitForm(); return false;"><fmt:message key="search"/></a>
            </td>
        </tr>
        </table>
        </form>
        <h3><fmt:message key="search.results"/></h3>
        <table  class="styledLeft"  style="width: 100%;margin-top:10px;">
            <thead>
                <tr>
                    <th><fmt:message key='resources'/></th>
                </tr>
            </thead>
            <tbody>
                <%
                    if(results != null && results.length > 0) {
                        for(String result : results){
                %>
                <tr>
                        <td><%=result%></td>
                </tr>
                <%
                        }
                    } else {
                %>
                    <tr>
                        <td>No Result is found</td>
                    </tr>

                <%
                    }
                %>
            </tbody>
        </table>
    </div>
</div>
</fmt:bundle>
